'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = matchExported;

var _babelExplodeModule = require('babel-explode-module');

var _babelExplodeModule2 = _interopRequireDefault(_babelExplodeModule);

var _babelHelperSimplifyModule = require('babel-helper-simplify-module');

var _babelLog = require('babel-log');

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function matchExported(file, exportName) {
  var exploded = (0, _babelExplodeModule2.default)(file.path.node);
  var statements = (0, _babelHelperSimplifyModule.explodedToStatements)(exploded);

  var program = Object.assign({}, file.path.node, {
    body: statements
  });

  file.path.replaceWith(program);

  var match = exploded.exports.find(function (item) {
    return item.external === exportName;
  });

  if (!match) {
    return null;
  }

  var statement = file.path.get('body').find(function (item) {
    if (!item.isDeclaration()) return false;

    var id = null;

    if (item.isVariableDeclaration()) {
      id = item.node.declarations[0].id;
    } else if (item.node.id) {
      id = item.node.id;
    } else {
      throw new Error('Unexpected node:\n\n' + (0, _babelLog.format)(item));
    }

    if (!id) {
      throw new Error('Couldn\'t find id on node:\n\n' + (0, _babelLog.format)(item));
    }

    return id.name === match.local;
  });

  return statement || null;
}